Imports System
Imports System.Windows.Forms
Imports System.Threading
Imports System.Net.Sockets
Imports AddiData.ADDISocket


Public Class CyclicAcquisition
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Private WithEvents GB_ModuleInfo As System.Windows.Forms.GroupBox
    Private WithEvents L_MSXEInfo As System.Windows.Forms.Label
    Private WithEvents B_Connect As System.Windows.Forms.Button
    Private WithEvents label3 As System.Windows.Forms.Label
    Private WithEvents label4 As System.Windows.Forms.Label
    Private WithEvents label5 As System.Windows.Forms.Label
    Private WithEvents TB_IPAddress_3 As System.Windows.Forms.TextBox
    Private WithEvents TB_IPAddress_2 As System.Windows.Forms.TextBox
    Private WithEvents TB_IPAddress_1 As System.Windows.Forms.TextBox
    Private WithEvents TB_IPAddress_0 As System.Windows.Forms.TextBox
    Private WithEvents label19 As System.Windows.Forms.Label
    Private WithEvents GB_AcquisitionInfo As System.Windows.Forms.GroupBox
    Friend WithEvents TB_Values As System.Windows.Forms.TextBox
    Private WithEvents B_CounterReleaseInitialisation As System.Windows.Forms.Button
    Private WithEvents B_StopCounterAcquisition As System.Windows.Forms.Button
    Private WithEvents B_StartCounterAcquisition As System.Windows.Forms.Button
    Private WithEvents B_WriteCounter As System.Windows.Forms.Button
    Private WithEvents B_ClearCounter As System.Windows.Forms.Button
    Private WithEvents label1 As System.Windows.Forms.Label
    Private WithEvents TB_WriteValue As System.Windows.Forms.TextBox
    Private WithEvents B_CounterInitialisation As System.Windows.Forms.Button
    Private WithEvents GB_Acquisition As System.Windows.Forms.GroupBox
    Private WithEvents label11 As System.Windows.Forms.Label
    Private WithEvents label10 As System.Windows.Forms.Label
    Private WithEvents LB_ReadTime As System.Windows.Forms.ComboBox
    Private WithEvents TB_TimeValue As System.Windows.Forms.TextBox
    Private WithEvents TB_TransferNbr As System.Windows.Forms.TextBox
    Private WithEvents label8 As System.Windows.Forms.Label
    Private WithEvents TB_SequenceNbr As System.Windows.Forms.TextBox
    Private WithEvents label7 As System.Windows.Forms.Label
    Private WithEvents GB_Help As System.Windows.Forms.GroupBox
    Private WithEvents L_Help As System.Windows.Forms.Label
    Private WithEvents GB_CounterConfig As System.Windows.Forms.GroupBox
    Private WithEvents CH_Counter3 As System.Windows.Forms.CheckBox
    Private WithEvents CH_Counter2 As System.Windows.Forms.CheckBox
    Private WithEvents CH_Counter1 As System.Windows.Forms.CheckBox
    Private WithEvents CH_Counter0 As System.Windows.Forms.CheckBox
    Private WithEvents L_IC_Label1 As System.Windows.Forms.Label
    Private WithEvents label2 As System.Windows.Forms.Label
    Private WithEvents L_IC_Label0 As System.Windows.Forms.Label
    Private WithEvents LB_IC_Option As System.Windows.Forms.ComboBox
    Private WithEvents LB_IC_Mode As System.Windows.Forms.ComboBox
    Private WithEvents DisplayTimer As System.Windows.Forms.Timer

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(CyclicAcquisition))
        Me.GB_ModuleInfo = New System.Windows.Forms.GroupBox
        Me.L_MSXEInfo = New System.Windows.Forms.Label
        Me.B_Connect = New System.Windows.Forms.Button
        Me.label3 = New System.Windows.Forms.Label
        Me.label4 = New System.Windows.Forms.Label
        Me.label5 = New System.Windows.Forms.Label
        Me.TB_IPAddress_3 = New System.Windows.Forms.TextBox
        Me.TB_IPAddress_2 = New System.Windows.Forms.TextBox
        Me.TB_IPAddress_1 = New System.Windows.Forms.TextBox
        Me.TB_IPAddress_0 = New System.Windows.Forms.TextBox
        Me.label19 = New System.Windows.Forms.Label
        Me.GB_AcquisitionInfo = New System.Windows.Forms.GroupBox
        Me.TB_Values = New System.Windows.Forms.TextBox
        Me.B_CounterReleaseInitialisation = New System.Windows.Forms.Button
        Me.B_StopCounterAcquisition = New System.Windows.Forms.Button
        Me.B_StartCounterAcquisition = New System.Windows.Forms.Button
        Me.B_WriteCounter = New System.Windows.Forms.Button
        Me.B_ClearCounter = New System.Windows.Forms.Button
        Me.label1 = New System.Windows.Forms.Label
        Me.TB_WriteValue = New System.Windows.Forms.TextBox
        Me.B_CounterInitialisation = New System.Windows.Forms.Button
        Me.GB_Acquisition = New System.Windows.Forms.GroupBox
        Me.label11 = New System.Windows.Forms.Label
        Me.label10 = New System.Windows.Forms.Label
        Me.LB_ReadTime = New System.Windows.Forms.ComboBox
        Me.TB_TimeValue = New System.Windows.Forms.TextBox
        Me.TB_TransferNbr = New System.Windows.Forms.TextBox
        Me.label8 = New System.Windows.Forms.Label
        Me.TB_SequenceNbr = New System.Windows.Forms.TextBox
        Me.label7 = New System.Windows.Forms.Label
        Me.GB_Help = New System.Windows.Forms.GroupBox
        Me.L_Help = New System.Windows.Forms.Label
        Me.GB_CounterConfig = New System.Windows.Forms.GroupBox
        Me.CH_Counter3 = New System.Windows.Forms.CheckBox
        Me.CH_Counter2 = New System.Windows.Forms.CheckBox
        Me.CH_Counter1 = New System.Windows.Forms.CheckBox
        Me.CH_Counter0 = New System.Windows.Forms.CheckBox
        Me.L_IC_Label1 = New System.Windows.Forms.Label
        Me.label2 = New System.Windows.Forms.Label
        Me.L_IC_Label0 = New System.Windows.Forms.Label
        Me.LB_IC_Option = New System.Windows.Forms.ComboBox
        Me.LB_IC_Mode = New System.Windows.Forms.ComboBox
        Me.DisplayTimer = New System.Windows.Forms.Timer(Me.components)
        Me.GB_ModuleInfo.SuspendLayout()
        Me.GB_AcquisitionInfo.SuspendLayout()
        Me.GB_Acquisition.SuspendLayout()
        Me.GB_Help.SuspendLayout()
        Me.GB_CounterConfig.SuspendLayout()
        Me.SuspendLayout()
        '
        'GB_ModuleInfo
        '
        Me.GB_ModuleInfo.Controls.Add(Me.L_MSXEInfo)
        Me.GB_ModuleInfo.Controls.Add(Me.B_Connect)
        Me.GB_ModuleInfo.Controls.Add(Me.label3)
        Me.GB_ModuleInfo.Controls.Add(Me.label4)
        Me.GB_ModuleInfo.Controls.Add(Me.label5)
        Me.GB_ModuleInfo.Controls.Add(Me.TB_IPAddress_3)
        Me.GB_ModuleInfo.Controls.Add(Me.TB_IPAddress_2)
        Me.GB_ModuleInfo.Controls.Add(Me.TB_IPAddress_1)
        Me.GB_ModuleInfo.Controls.Add(Me.TB_IPAddress_0)
        Me.GB_ModuleInfo.Controls.Add(Me.label19)
        Me.GB_ModuleInfo.Location = New System.Drawing.Point(12, 123)
        Me.GB_ModuleInfo.Name = "GB_ModuleInfo"
        Me.GB_ModuleInfo.Size = New System.Drawing.Size(836, 58)
        Me.GB_ModuleInfo.TabIndex = 113
        Me.GB_ModuleInfo.TabStop = False
        Me.GB_ModuleInfo.Text = "Module selection"
        '
        'L_MSXEInfo
        '
        Me.L_MSXEInfo.Location = New System.Drawing.Point(544, 13)
        Me.L_MSXEInfo.Name = "L_MSXEInfo"
        Me.L_MSXEInfo.Size = New System.Drawing.Size(286, 36)
        Me.L_MSXEInfo.TabIndex = 102
        Me.L_MSXEInfo.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'B_Connect
        '
        Me.B_Connect.Location = New System.Drawing.Point(447, 20)
        Me.B_Connect.Name = "B_Connect"
        Me.B_Connect.Size = New System.Drawing.Size(91, 29)
        Me.B_Connect.TabIndex = 97
        Me.B_Connect.Text = "Connect"
        Me.B_Connect.UseVisualStyleBackColor = True
        '
        'label3
        '
        Me.label3.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.label3.Location = New System.Drawing.Point(393, 25)
        Me.label3.Name = "label3"
        Me.label3.Size = New System.Drawing.Size(8, 16)
        Me.label3.TabIndex = 101
        Me.label3.Text = "-"
        '
        'label4
        '
        Me.label4.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.label4.Location = New System.Drawing.Point(337, 25)
        Me.label4.Name = "label4"
        Me.label4.Size = New System.Drawing.Size(8, 16)
        Me.label4.TabIndex = 100
        Me.label4.Text = "-"
        '
        'label5
        '
        Me.label5.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.label5.Location = New System.Drawing.Point(281, 25)
        Me.label5.Name = "label5"
        Me.label5.Size = New System.Drawing.Size(8, 16)
        Me.label5.TabIndex = 99
        Me.label5.Text = "-"
        '
        'TB_IPAddress_3
        '
        Me.TB_IPAddress_3.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!)
        Me.TB_IPAddress_3.Location = New System.Drawing.Point(409, 25)
        Me.TB_IPAddress_3.MaxLength = 3
        Me.TB_IPAddress_3.Name = "TB_IPAddress_3"
        Me.TB_IPAddress_3.Size = New System.Drawing.Size(32, 20)
        Me.TB_IPAddress_3.TabIndex = 96
        '
        'TB_IPAddress_2
        '
        Me.TB_IPAddress_2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!)
        Me.TB_IPAddress_2.Location = New System.Drawing.Point(353, 25)
        Me.TB_IPAddress_2.MaxLength = 3
        Me.TB_IPAddress_2.Name = "TB_IPAddress_2"
        Me.TB_IPAddress_2.Size = New System.Drawing.Size(32, 20)
        Me.TB_IPAddress_2.TabIndex = 95
        '
        'TB_IPAddress_1
        '
        Me.TB_IPAddress_1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!)
        Me.TB_IPAddress_1.Location = New System.Drawing.Point(297, 25)
        Me.TB_IPAddress_1.MaxLength = 3
        Me.TB_IPAddress_1.Name = "TB_IPAddress_1"
        Me.TB_IPAddress_1.Size = New System.Drawing.Size(32, 20)
        Me.TB_IPAddress_1.TabIndex = 94
        '
        'TB_IPAddress_0
        '
        Me.TB_IPAddress_0.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!)
        Me.TB_IPAddress_0.ImeMode = System.Windows.Forms.ImeMode.Disable
        Me.TB_IPAddress_0.Location = New System.Drawing.Point(241, 25)
        Me.TB_IPAddress_0.MaxLength = 3
        Me.TB_IPAddress_0.Name = "TB_IPAddress_0"
        Me.TB_IPAddress_0.Size = New System.Drawing.Size(32, 20)
        Me.TB_IPAddress_0.TabIndex = 93
        '
        'label19
        '
        Me.label19.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.label19.Location = New System.Drawing.Point(27, 27)
        Me.label19.Name = "label19"
        Me.label19.Size = New System.Drawing.Size(208, 16)
        Me.label19.TabIndex = 98
        Me.label19.Text = "IP address of the MSX-E170x module :"
        '
        'GB_AcquisitionInfo
        '
        Me.GB_AcquisitionInfo.Controls.Add(Me.TB_Values)
        Me.GB_AcquisitionInfo.Location = New System.Drawing.Point(12, 388)
        Me.GB_AcquisitionInfo.Name = "GB_AcquisitionInfo"
        Me.GB_AcquisitionInfo.Size = New System.Drawing.Size(842, 138)
        Me.GB_AcquisitionInfo.TabIndex = 112
        Me.GB_AcquisitionInfo.TabStop = False
        Me.GB_AcquisitionInfo.Text = "Sequence information"
        '
        'TB_Values
        '
        Me.TB_Values.Font = New System.Drawing.Font("Courier New", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TB_Values.Location = New System.Drawing.Point(11, 19)
        Me.TB_Values.Multiline = True
        Me.TB_Values.Name = "TB_Values"
        Me.TB_Values.ReadOnly = True
        Me.TB_Values.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.TB_Values.Size = New System.Drawing.Size(819, 107)
        Me.TB_Values.TabIndex = 140
        Me.TB_Values.TabStop = False
        '
        'B_CounterReleaseInitialisation
        '
        Me.B_CounterReleaseInitialisation.Enabled = False
        Me.B_CounterReleaseInitialisation.Location = New System.Drawing.Point(108, 353)
        Me.B_CounterReleaseInitialisation.Name = "B_CounterReleaseInitialisation"
        Me.B_CounterReleaseInitialisation.Size = New System.Drawing.Size(173, 29)
        Me.B_CounterReleaseInitialisation.TabIndex = 103
        Me.B_CounterReleaseInitialisation.Text = "Release counter(s) initialisation"
        Me.B_CounterReleaseInitialisation.UseVisualStyleBackColor = True
        '
        'B_StopCounterAcquisition
        '
        Me.B_StopCounterAcquisition.Enabled = False
        Me.B_StopCounterAcquisition.Location = New System.Drawing.Point(538, 353)
        Me.B_StopCounterAcquisition.Name = "B_StopCounterAcquisition"
        Me.B_StopCounterAcquisition.Size = New System.Drawing.Size(173, 29)
        Me.B_StopCounterAcquisition.TabIndex = 108
        Me.B_StopCounterAcquisition.Text = "Stop cyclic acquisition"
        Me.B_StopCounterAcquisition.UseVisualStyleBackColor = True
        '
        'B_StartCounterAcquisition
        '
        Me.B_StartCounterAcquisition.Enabled = False
        Me.B_StartCounterAcquisition.Location = New System.Drawing.Point(538, 318)
        Me.B_StartCounterAcquisition.Name = "B_StartCounterAcquisition"
        Me.B_StartCounterAcquisition.Size = New System.Drawing.Size(173, 29)
        Me.B_StartCounterAcquisition.TabIndex = 107
        Me.B_StartCounterAcquisition.Text = "Start cyclic acquisition"
        Me.B_StartCounterAcquisition.UseVisualStyleBackColor = True
        '
        'B_WriteCounter
        '
        Me.B_WriteCounter.Enabled = False
        Me.B_WriteCounter.Location = New System.Drawing.Point(321, 353)
        Me.B_WriteCounter.Name = "B_WriteCounter"
        Me.B_WriteCounter.Size = New System.Drawing.Size(93, 29)
        Me.B_WriteCounter.TabIndex = 105
        Me.B_WriteCounter.Text = "Write counter(s)"
        Me.B_WriteCounter.UseVisualStyleBackColor = True
        '
        'B_ClearCounter
        '
        Me.B_ClearCounter.Enabled = False
        Me.B_ClearCounter.Location = New System.Drawing.Point(321, 318)
        Me.B_ClearCounter.Name = "B_ClearCounter"
        Me.B_ClearCounter.Size = New System.Drawing.Size(173, 29)
        Me.B_ClearCounter.TabIndex = 104
        Me.B_ClearCounter.Text = "Clear counter(s)"
        Me.B_ClearCounter.UseVisualStyleBackColor = True
        '
        'label1
        '
        Me.label1.Location = New System.Drawing.Point(12, 9)
        Me.label1.Name = "label1"
        Me.label1.Size = New System.Drawing.Size(822, 24)
        Me.label1.TabIndex = 101
        Me.label1.Text = "This sample make a cyclic acquisition from the counters via the sanchro timer and" & _
            " the synchro latch event"
        '
        'TB_WriteValue
        '
        Me.TB_WriteValue.Location = New System.Drawing.Point(420, 358)
        Me.TB_WriteValue.Name = "TB_WriteValue"
        Me.TB_WriteValue.Size = New System.Drawing.Size(74, 20)
        Me.TB_WriteValue.TabIndex = 106
        Me.TB_WriteValue.Text = "0"
        '
        'B_CounterInitialisation
        '
        Me.B_CounterInitialisation.Enabled = False
        Me.B_CounterInitialisation.Location = New System.Drawing.Point(108, 318)
        Me.B_CounterInitialisation.Name = "B_CounterInitialisation"
        Me.B_CounterInitialisation.Size = New System.Drawing.Size(173, 29)
        Me.B_CounterInitialisation.TabIndex = 102
        Me.B_CounterInitialisation.Text = "Counter(s) initialisation"
        Me.B_CounterInitialisation.UseVisualStyleBackColor = True
        '
        'GB_Acquisition
        '
        Me.GB_Acquisition.Controls.Add(Me.label11)
        Me.GB_Acquisition.Controls.Add(Me.label10)
        Me.GB_Acquisition.Controls.Add(Me.LB_ReadTime)
        Me.GB_Acquisition.Controls.Add(Me.TB_TimeValue)
        Me.GB_Acquisition.Controls.Add(Me.TB_TransferNbr)
        Me.GB_Acquisition.Controls.Add(Me.label8)
        Me.GB_Acquisition.Controls.Add(Me.TB_SequenceNbr)
        Me.GB_Acquisition.Controls.Add(Me.label7)
        Me.GB_Acquisition.Location = New System.Drawing.Point(346, 187)
        Me.GB_Acquisition.Name = "GB_Acquisition"
        Me.GB_Acquisition.Size = New System.Drawing.Size(502, 126)
        Me.GB_Acquisition.TabIndex = 111
        Me.GB_Acquisition.TabStop = False
        Me.GB_Acquisition.Text = "Acquisition configuration"
        '
        'label11
        '
        Me.label11.AutoSize = True
        Me.label11.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.label11.Location = New System.Drawing.Point(27, 94)
        Me.label11.Name = "label11"
        Me.label11.Size = New System.Drawing.Size(84, 13)
        Me.label11.TabIndex = 96
        Me.label11.Text = "Read time value"
        '
        'label10
        '
        Me.label10.AutoSize = True
        Me.label10.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.label10.Location = New System.Drawing.Point(27, 71)
        Me.label10.Name = "label10"
        Me.label10.Size = New System.Drawing.Size(84, 13)
        Me.label10.TabIndex = 95
        Me.label10.Text = "Read time base "
        '
        'LB_ReadTime
        '
        Me.LB_ReadTime.AllowDrop = True
        Me.LB_ReadTime.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.LB_ReadTime.FormattingEnabled = True
        Me.LB_ReadTime.Location = New System.Drawing.Point(376, 68)
        Me.LB_ReadTime.Name = "LB_ReadTime"
        Me.LB_ReadTime.Size = New System.Drawing.Size(92, 21)
        Me.LB_ReadTime.TabIndex = 12
        '
        'TB_TimeValue
        '
        Me.TB_TimeValue.Location = New System.Drawing.Point(377, 92)
        Me.TB_TimeValue.Name = "TB_TimeValue"
        Me.TB_TimeValue.Size = New System.Drawing.Size(91, 20)
        Me.TB_TimeValue.TabIndex = 13
        Me.TB_TimeValue.Text = "25"
        '
        'TB_TransferNbr
        '
        Me.TB_TransferNbr.Location = New System.Drawing.Point(377, 45)
        Me.TB_TransferNbr.Name = "TB_TransferNbr"
        Me.TB_TransferNbr.Size = New System.Drawing.Size(91, 20)
        Me.TB_TransferNbr.TabIndex = 11
        Me.TB_TransferNbr.Text = "10"
        '
        'label8
        '
        Me.label8.AutoSize = True
        Me.label8.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.label8.Location = New System.Drawing.Point(27, 48)
        Me.label8.Name = "label8"
        Me.label8.Size = New System.Drawing.Size(332, 13)
        Me.label8.TabIndex = 88
        Me.label8.Text = "Nbr of read sequences to acquire before the data are sent  (1 to 200)"
        '
        'TB_SequenceNbr
        '
        Me.TB_SequenceNbr.Location = New System.Drawing.Point(377, 22)
        Me.TB_SequenceNbr.Name = "TB_SequenceNbr"
        Me.TB_SequenceNbr.Size = New System.Drawing.Size(91, 20)
        Me.TB_SequenceNbr.TabIndex = 10
        Me.TB_SequenceNbr.Text = "100"
        '
        'label7
        '
        Me.label7.AutoSize = True
        Me.label7.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.label7.Location = New System.Drawing.Point(27, 25)
        Me.label7.Name = "label7"
        Me.label7.Size = New System.Drawing.Size(327, 13)
        Me.label7.TabIndex = 86
        Me.label7.Text = "How many read counter (s) sequence must be run (0 for continuous)"
        '
        'GB_Help
        '
        Me.GB_Help.Controls.Add(Me.L_Help)
        Me.GB_Help.Location = New System.Drawing.Point(12, 55)
        Me.GB_Help.Name = "GB_Help"
        Me.GB_Help.Size = New System.Drawing.Size(836, 56)
        Me.GB_Help.TabIndex = 110
        Me.GB_Help.TabStop = False
        Me.GB_Help.Text = "Help"
        '
        'L_Help
        '
        Me.L_Help.Location = New System.Drawing.Point(8, 16)
        Me.L_Help.Name = "L_Help"
        Me.L_Help.Size = New System.Drawing.Size(822, 32)
        Me.L_Help.TabIndex = 0
        Me.L_Help.Text = resources.GetString("L_Help.Text")
        Me.L_Help.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'GB_CounterConfig
        '
        Me.GB_CounterConfig.Controls.Add(Me.CH_Counter3)
        Me.GB_CounterConfig.Controls.Add(Me.CH_Counter2)
        Me.GB_CounterConfig.Controls.Add(Me.CH_Counter1)
        Me.GB_CounterConfig.Controls.Add(Me.CH_Counter0)
        Me.GB_CounterConfig.Controls.Add(Me.L_IC_Label1)
        Me.GB_CounterConfig.Controls.Add(Me.label2)
        Me.GB_CounterConfig.Controls.Add(Me.L_IC_Label0)
        Me.GB_CounterConfig.Controls.Add(Me.LB_IC_Option)
        Me.GB_CounterConfig.Controls.Add(Me.LB_IC_Mode)
        Me.GB_CounterConfig.Location = New System.Drawing.Point(12, 187)
        Me.GB_CounterConfig.Name = "GB_CounterConfig"
        Me.GB_CounterConfig.Size = New System.Drawing.Size(326, 126)
        Me.GB_CounterConfig.TabIndex = 109
        Me.GB_CounterConfig.TabStop = False
        Me.GB_CounterConfig.Text = "Counter(s) configuration"
        '
        'CH_Counter3
        '
        Me.CH_Counter3.AutoSize = True
        Me.CH_Counter3.Checked = True
        Me.CH_Counter3.CheckState = System.Windows.Forms.CheckState.Checked
        Me.CH_Counter3.Location = New System.Drawing.Point(269, 31)
        Me.CH_Counter3.Name = "CH_Counter3"
        Me.CH_Counter3.Size = New System.Drawing.Size(32, 17)
        Me.CH_Counter3.TabIndex = 7
        Me.CH_Counter3.Text = "3"
        Me.CH_Counter3.UseVisualStyleBackColor = True
        '
        'CH_Counter2
        '
        Me.CH_Counter2.AutoSize = True
        Me.CH_Counter2.Checked = True
        Me.CH_Counter2.CheckState = System.Windows.Forms.CheckState.Checked
        Me.CH_Counter2.Location = New System.Drawing.Point(231, 31)
        Me.CH_Counter2.Name = "CH_Counter2"
        Me.CH_Counter2.Size = New System.Drawing.Size(32, 17)
        Me.CH_Counter2.TabIndex = 6
        Me.CH_Counter2.Text = "2"
        Me.CH_Counter2.UseVisualStyleBackColor = True
        '
        'CH_Counter1
        '
        Me.CH_Counter1.AutoSize = True
        Me.CH_Counter1.Checked = True
        Me.CH_Counter1.CheckState = System.Windows.Forms.CheckState.Checked
        Me.CH_Counter1.Location = New System.Drawing.Point(193, 31)
        Me.CH_Counter1.Name = "CH_Counter1"
        Me.CH_Counter1.Size = New System.Drawing.Size(32, 17)
        Me.CH_Counter1.TabIndex = 5
        Me.CH_Counter1.Text = "1"
        Me.CH_Counter1.UseVisualStyleBackColor = True
        '
        'CH_Counter0
        '
        Me.CH_Counter0.AutoSize = True
        Me.CH_Counter0.Checked = True
        Me.CH_Counter0.CheckState = System.Windows.Forms.CheckState.Checked
        Me.CH_Counter0.Location = New System.Drawing.Point(155, 31)
        Me.CH_Counter0.Name = "CH_Counter0"
        Me.CH_Counter0.Size = New System.Drawing.Size(32, 17)
        Me.CH_Counter0.TabIndex = 4
        Me.CH_Counter0.Text = "0"
        Me.CH_Counter0.UseVisualStyleBackColor = True
        '
        'L_IC_Label1
        '
        Me.L_IC_Label1.AutoSize = True
        Me.L_IC_Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.L_IC_Label1.Location = New System.Drawing.Point(27, 80)
        Me.L_IC_Label1.Name = "L_IC_Label1"
        Me.L_IC_Label1.Size = New System.Drawing.Size(87, 13)
        Me.L_IC_Label1.TabIndex = 47
        Me.L_IC_Label1.Text = "Counter(s) option"
        '
        'label2
        '
        Me.label2.AutoSize = True
        Me.label2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.label2.Location = New System.Drawing.Point(27, 31)
        Me.label2.Name = "label2"
        Me.label2.Size = New System.Drawing.Size(100, 13)
        Me.label2.TabIndex = 46
        Me.label2.Text = "Counter(s) selection"
        '
        'L_IC_Label0
        '
        Me.L_IC_Label0.AutoSize = True
        Me.L_IC_Label0.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.L_IC_Label0.Location = New System.Drawing.Point(27, 56)
        Me.L_IC_Label0.Name = "L_IC_Label0"
        Me.L_IC_Label0.Size = New System.Drawing.Size(84, 13)
        Me.L_IC_Label0.TabIndex = 46
        Me.L_IC_Label0.Text = "Counter(s) mode"
        '
        'LB_IC_Option
        '
        Me.LB_IC_Option.AllowDrop = True
        Me.LB_IC_Option.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.LB_IC_Option.FormattingEnabled = True
        Me.LB_IC_Option.Location = New System.Drawing.Point(145, 77)
        Me.LB_IC_Option.Name = "LB_IC_Option"
        Me.LB_IC_Option.Size = New System.Drawing.Size(146, 21)
        Me.LB_IC_Option.TabIndex = 9
        '
        'LB_IC_Mode
        '
        Me.LB_IC_Mode.AllowDrop = True
        Me.LB_IC_Mode.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.LB_IC_Mode.FormattingEnabled = True
        Me.LB_IC_Mode.Location = New System.Drawing.Point(145, 54)
        Me.LB_IC_Mode.Name = "LB_IC_Mode"
        Me.LB_IC_Mode.Size = New System.Drawing.Size(146, 21)
        Me.LB_IC_Mode.TabIndex = 8
        '
        'DisplayTimer
        '
        Me.DisplayTimer.Interval = 1
        '
        'CyclicAcquisition
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(862, 535)
        Me.Controls.Add(Me.GB_ModuleInfo)
        Me.Controls.Add(Me.GB_AcquisitionInfo)
        Me.Controls.Add(Me.B_CounterReleaseInitialisation)
        Me.Controls.Add(Me.B_StopCounterAcquisition)
        Me.Controls.Add(Me.B_StartCounterAcquisition)
        Me.Controls.Add(Me.B_WriteCounter)
        Me.Controls.Add(Me.B_ClearCounter)
        Me.Controls.Add(Me.label1)
        Me.Controls.Add(Me.TB_WriteValue)
        Me.Controls.Add(Me.B_CounterInitialisation)
        Me.Controls.Add(Me.GB_Acquisition)
        Me.Controls.Add(Me.GB_Help)
        Me.Controls.Add(Me.GB_CounterConfig)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "CyclicAcquisition"
        Me.Text = "VB .NET Cyclic acquisition"
        Me.GB_ModuleInfo.ResumeLayout(False)
        Me.GB_ModuleInfo.PerformLayout()
        Me.GB_AcquisitionInfo.ResumeLayout(False)
        Me.GB_AcquisitionInfo.PerformLayout()
        Me.GB_Acquisition.ResumeLayout(False)
        Me.GB_Acquisition.PerformLayout()
        Me.GB_Help.ResumeLayout(False)
        Me.GB_CounterConfig.ResumeLayout(False)
        Me.GB_CounterConfig.PerformLayout()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region


    Public Class ListData
        Private myItem As String
        Private myValue As Long

        Public Sub New(ByVal strItem As String, ByVal lValue As Long)
            myItem = strItem
            myValue = lValue
        End Sub

        ReadOnly Property Item() As String
            Get
                Item = myItem
                Exit Property
            End Get
        End Property

        ReadOnly Property Value() As Long
            Get
                Value = myValue
                Exit Property
            End Get
        End Property
    End Class

    Dim MX_Common As MXCommon_WebReference.MXCommon
    Dim MSXE170x As MSXE170x_WebReference.MSXE170x
    Dim SocketClient As Socket = Nothing
    Dim DisplayText As String = ""
    Dim Client As AddiData.ADDISocket.AsyncClientStream = Nothing
    Dim CounterList() As CheckBox
    Dim Counters As Integer = 0
    Dim CounterOptions0 As ArrayList = New ArrayList()
    Dim CounterOptions1 As ArrayList = New ArrayList()


    Public Function ConvertFromTime_T(ByVal bBuffer() As Byte, ByVal iIndex As Integer) As String

        Dim ulTimeStampHigh As System.UInt64 = BitConverter.ToUInt32(bBuffer, iIndex + 4)
        Dim ulTimeStampLow As System.UInt64 = BitConverter.ToUInt32(bBuffer, iIndex + 0)

        Return (ConvertFromTime_T(ulTimeStampHigh, ulTimeStampLow))
    End Function

    Public Function ConvertFromTime_T(ByVal ulTimeStampHigh As System.UInt64, ByVal ulTimeStampLow As System.UInt64) As String
        Dim ulTimeStampLowms As System.UInt64 = CType((ulTimeStampLow / 1000), System.UInt64)
        Dim ulTimeStampLowmus As System.UInt64 = CType((ulTimeStampLow Mod 1000), System.UInt64)

        Dim dt70 = New DateTime(1970, 1, 1, 0, 0, 0, 0)
        Dim tickTotal As Long = dt70.Ticks + CType((ulTimeStampHigh * 10000000L), Long)
        Dim netTimeT = New DateTime(tickTotal)
        Return (netTimeT.ToString() + "." + ulTimeStampLowms.ToString("D3") + "." + ulTimeStampLowmus.ToString("D3"))
    End Function

    Private Sub CyclicAcquisition_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MX_Common = New MXCommon_WebReference.MXCommon()
        MSXE170x = New MSXE170x_WebReference.MSXE170x()
        MX_Common.Timeout = 2000
        MSXE170x.Timeout = 2000

        ' Counter option list box initialisation 
        CounterOptions0.Add(New ListData("Hysteresus on", 1))
        CounterOptions0.Add(New ListData("Hysteresus off", 0))
        CounterOptions1.Add(New ListData("Increment", 0))
        CounterOptions1.Add(New ListData("Decrement", 1))

        LB_IC_Option.DataSource = CounterOptions0
        LB_IC_Option.DisplayMember = "Item"
        LB_IC_Option.ValueMember = "Value"

        ' Counter mode list box initialisation
        Dim CounterModes = New ArrayList()
        CounterModes.Add(New ListData("Simple mode", 1))
        CounterModes.Add(New ListData("Double mode", 2))
        CounterModes.Add(New ListData("Quadruple mode", 4))
        CounterModes.Add(New ListData("Direct", 0))

        LB_IC_Mode.DisplayMember = "Item"
        LB_IC_Mode.ValueMember = "Value"
        LB_IC_Mode.DataSource = CounterModes

        ' Read time list box initialisation
        Dim ReadTimes = New ArrayList()
        ReadTimes.Add(New ListData("s", 0))
        ReadTimes.Add(New ListData("ms", 1))
        ReadTimes.Add(New ListData("s", 2))

        LB_ReadTime.DisplayMember = "Item"
        LB_ReadTime.ValueMember = "Value"
        LB_ReadTime.DataSource = ReadTimes

        ' Counter list initialisation
        ReDim CounterList(4)
        CounterList(0) = CH_Counter0
        CounterList(1) = CH_Counter1
        CounterList(2) = CH_Counter2
        CounterList(3) = CH_Counter3

    End Sub

    Private Sub CyclicAcquisition_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        CloseAll()

        If Not MSXE170x Is Nothing Then
            MSXE170x = Nothing
        End If
        If Not MX_Common Is Nothing Then
            MX_Common = Nothing
        End If

        System.GC.Collect()

        System.GC.Collect()
    End Sub

    Private Sub LB_IC_Mode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LB_IC_Mode.SelectedIndexChanged
        If (Convert.ToUInt32(LB_IC_Mode.SelectedValue) = 0) Then
            LB_IC_Option.DataSource = CounterOptions1
        Else
            LB_IC_Option.DataSource = CounterOptions0
        End If
    End Sub

    Private Sub CloseAll()
        ' Test if any acquisition in progress
        If (B_StopCounterAcquisition.Enabled = True) Then
            ' Test the current acquisition
            B_StopCounterAcquisition_Click(Nothing, Nothing)
        End If

        ' Test if counter initialised
        If (B_CounterReleaseInitialisation.Enabled = True) Then
            ' Release the counter initialisation
            B_CounterReleaseInitialisation_Click(Nothing, Nothing)
        End If
    End Sub

    Private Sub B_Connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_Connect.Click
        Dim bModuleType(200) As Byte
        Dim ASCIIEnc As System.Text.ASCIIEncoding = New System.Text.ASCIIEncoding()

        If ((TB_IPAddress_0.Text.ToString() = "") Or (TB_IPAddress_1.Text.ToString() = "") Or (TB_IPAddress_2.Text.ToString() = "") Or (TB_IPAddress_3.Text.ToString() = "")) Then
            MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            If ((Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256)) Then
                If ((Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256)) Then
                    If ((Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256)) Then
                        If ((Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) And (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256)) Then
                            CloseAll()

                            Try
                                MSXE170x.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555"
                                MX_Common.Url = MSXE170x.Url

                                ' Get the module type
                                MX_Common.GetModuleType(bModuleType)
                                L_MSXEInfo.Text = ASCIIEnc.GetString(bModuleType)

                                ' Button initialisation
                                B_CounterInitialisation.Enabled = True
                                B_CounterReleaseInitialisation.Enabled = False
                                B_ClearCounter.Enabled = False
                                B_WriteCounter.Enabled = False
                                B_StartCounterAcquisition.Enabled = False
                                B_StopCounterAcquisition.Enabled = False
                                GB_CounterConfig.Enabled = True
                                GB_Acquisition.Enabled = True

                            Catch ex As Exception

                                MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            End Try
                        Else
                            MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        End If
                    Else
                        MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    End If
                Else
                    MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            Else
                MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        End If
    End Sub

    Private Sub B_CounterInitialisation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_CounterInitialisation.Click
        Dim i As Integer
        Dim j As Integer
        Dim syserno As Integer = 0
        Dim RetValue As Integer = 0
        Dim boErrorOccur As Boolean = False

        Counters = 0

        ' Counter(s) initialisation
        For i = 0 To 3

            ' Test if counter used
            If ((CounterList(i).Checked = True) And (boErrorOccur = False)) Then

                Try
                    ' Init the counter
                    RetValue = MSXE170x.MFIncCounterInit(i, Convert.ToUInt32(LB_IC_Mode.SelectedValue), Convert.ToUInt32(LB_IC_Option.SelectedValue), 0, 0, 0, 0, syserno)

                    If (RetValue <> 0) Then
                        boErrorOccur = True
                        MessageBox.Show("MFIncCounterInit Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

                        ' Test if any counter already initialised
                        If (Counters <> 0) Then
                            For j = 0 To j < (i - 1)
                                ' Test if counter used
                                If (CounterList(j).Enabled = True) Then
                                    MSXE170x.MFIncCounterRelease(j, syserno)
                                End If
                            Next j
                        End If
                    Else
                        Counters = Counters + 1
                    End If

                Catch ex As Exception
                    boErrorOccur = True
                    MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End Try
            End If
        Next i

        ' Test if no counter selected
        If ((Counters = 0) And (boErrorOccur = False)) Then

            MessageBox.Show("No counter(s) selected", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

        ElseIf (boErrorOccur = False) Then

            ' Button initialisation
            B_CounterInitialisation.Enabled = False
            B_CounterReleaseInitialisation.Enabled = True
            B_ClearCounter.Enabled = True
            B_WriteCounter.Enabled = True
            B_StartCounterAcquisition.Enabled = True
            B_StopCounterAcquisition.Enabled = False
            GB_CounterConfig.Enabled = False
            GB_Acquisition.Enabled = True
        End If
    End Sub

    Private Sub B_CounterReleaseInitialisation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_CounterReleaseInitialisation.Click
        Dim i As Integer
        Dim syserno As Integer = 0
        Dim RetValue As Integer = 0

        ' Counter(s) release
        For i = 0 To 3

            ' Test if counter used
            If (CounterList(i).Checked = True) Then

                ' Release the counter initialisation
                RetValue = MSXE170x.MFIncCounterRelease(i, syserno)

                ' Init the counter
                If (RetValue <> 0) Then

                    MessageBox.Show("MFIncCounterRelease Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            End If
        Next i

        ' Button initialisation
        B_CounterInitialisation.Enabled = True
        B_CounterReleaseInitialisation.Enabled = False
        B_ClearCounter.Enabled = False
        B_WriteCounter.Enabled = False
        B_StartCounterAcquisition.Enabled = False
        B_StopCounterAcquisition.Enabled = False
        GB_CounterConfig.Enabled = True
        GB_Acquisition.Enabled = True
    End Sub

    Private Sub B_ClearCounter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_ClearCounter.Click
        Dim i As Integer
        Dim syserno As Integer = 0
        Dim RetValue As Integer = 0

        ' Clear counter(s)
        For i = 0 To 3

            ' Test if counter used
            If (CounterList(i).Checked = True) Then

                ' Clear the counter 
                RetValue = MSXE170x.MFIncCounterClear(i, syserno)

                If (RetValue <> 0) Then

                    MessageBox.Show("MFIncCounterClear Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            End If
        Next i
    End Sub

    Private Sub B_WriteCounter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_WriteCounter.Click
        Dim i As Integer
        Dim syserno As Integer = 0
        Dim RetValue As Integer = 0

        ' Clear counter(s)
        For i = 0 To 3
            ' Test if counter used
            If (CounterList(i).Checked = True) Then

                ' Write the counter 
                RetValue = MSXE170x.MFIncCounterWrite32BitValue(i, Convert.ToUInt32(TB_WriteValue.Text), syserno)

                If (RetValue <> 0) Then

                    MessageBox.Show("MFIncCounterWrite32BitValue Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            End If
        Next i
    End Sub

    Private Sub B_StartCounterAcquisition_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_StartCounterAcquisition.Click
        Dim i As Integer
        Dim j As Integer
        Dim syserno As Integer = 0
        Dim RetValue As Integer = 0
        Dim boErrorOccur As Boolean = False
        Dim FIFOSize As Long = Convert.ToUInt32(TB_TransferNbr.Text)
        Dim SequenceNbr As Long = Convert.ToUInt32(TB_SequenceNbr.Text)
        Dim ClientThread As Thread

        ' Test the FIFO size
        If ((FIFOSize >= 1) And (FIFOSize <= 200)) Then

            If ((SequenceNbr < FIFOSize) And (SequenceNbr <> 0)) Then

                MessageBox.Show("Number of read sequence to acquire > total read sequence number", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If

            ' Create the client stream
            Client = New AddiData.ADDISocket.AsyncClientStream()

            ' Open the socket connection to receive the data
            SocketClient = Nothing
            SocketClient = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
            SocketClient.ReceiveBufferSize = 1048576
            SocketClient.Connect(TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text, 8989)

            ' Start the read socket and the user thread
            Client.SingleFramesSize = 5 * 4 * Counters
            Client.NbrOfFrames = Convert.ToInt32(FIFOSize)
            Client.Start(SocketClient)
            ClientThread = New Thread(AddressOf ClientThreadFct)
            DisplayText = ""

            ' Counter(s) synchro latch initialisation
            For i = 0 To 3

                ' Test if counter used
                If (CounterList(i).Checked = True) And (boErrorOccur = False) Then

                    ' Counter FIFO initialisation
                    RetValue = MSXE170x.MFIncCounterSetFIFO0Level(i, FIFOSize, 0, 0, syserno)

                    If (RetValue <> 0) Then

                        MessageBox.Show("MFIncCounterSetFIFO0Level Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        boErrorOccur = True
                    Else

                        ' Init the counter synchro latch
                        RetValue = MSXE170x.MFIncCounterInitAndEnableLatchRegister(i, 1, 0, 0, 0, syserno)

                        If (RetValue <> 0) Then

                            boErrorOccur = True
                            MessageBox.Show("MFIncCounterInitAndEnableLatchRegister Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        End If
                    End If

                    If (boErrorOccur = True) Then

                        For j = 0 To 3
                            ' Test if counter used
                            If (CounterList(j).Enabled = True) Then

                                MSXE170x.MFIncCounterDisableAndReleaseLatchRegister(j, 1, 0, syserno)
                            End If
                        Next j
                    End If
                End If
            Next i

            ' Test if no error occur
            If (boErrorOccur = False) Then

                ' Init and start the synchro timer
                RetValue = MX_Common.InitAndStartSynchroTimer(Convert.ToUInt32(LB_ReadTime.SelectedValue), _
                                                              Convert.ToUInt32(TB_TimeValue.Text), _
                                                              Convert.ToUInt32(TB_SequenceNbr.Text), _
                                                              0, _
                                                              0, _
                                                              0, _
                                                              0, _
                                                              0, _
                                                              syserno)

                If (RetValue <> 0) Then
                    boErrorOccur = True
                    MessageBox.Show("InitAndStartSynchroTimer Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

                    For i = 0 To 3
                        ' Test if counter used
                        If (CounterList(i).Enabled = True) Then

                            ' Disable the syncho latch
                            MSXE170x.MFIncCounterDisableAndReleaseLatchRegister(i, 1, 0, syserno)
                        End If
                    Next i
                Else
                    ' Start the display timer and read socket thread
                    DisplayTimer.Enabled = True
                    ClientThread.Priority = ThreadPriority.Lowest
                    ClientThread.Start()

                    ' Button initialisation
                    B_CounterInitialisation.Enabled = False
                    B_CounterReleaseInitialisation.Enabled = False
                    B_ClearCounter.Enabled = True
                    B_WriteCounter.Enabled = True
                    B_StartCounterAcquisition.Enabled = False
                    B_StopCounterAcquisition.Enabled = True
                    GB_CounterConfig.Enabled = False
                    GB_Acquisition.Enabled = False
                End If
            End If

            ' Test if error occur
            If (boErrorOccur = True) Then

                ' Stop the data server 
                Client.Stoop()

                Try
                    ' Close the socket connection
                    SocketClient.Shutdown(SocketShutdown.Both)
                    SocketClient.Close()
                    SocketClient = Nothing
                    System.GC.Collect()

                Catch ex As Exception
                    MessageBox.Show("Socket close connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End Try
            End If
        Else

            MessageBox.Show("Number of read sequence to acquire not OK", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If

    End Sub

    Private Sub B_StopCounterAcquisition_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_StopCounterAcquisition.Click
        Dim i As Integer
        Dim syserno As Integer = 0
        Dim RetValue As Integer = 0

        ' Stop the data server 
        Client.Stoop()

        Try
            ' Close the socket connection
            SocketClient.Shutdown(SocketShutdown.Both)
            SocketClient.Close()
            SocketClient = Nothing
            System.GC.Collect()

        Catch Ex As Exception
            MessageBox.Show("Socket close connection exception occur : " + Ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try

        ' Stop and release the synchro timer
        RetValue = MX_Common.StopAndReleaseSynchroTimer(0, syserno)

        If (RetValue <> 0) Then

            MessageBox.Show("StopAndReleaseSynchroTimer Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If

        ' Disable synchro latch from counter(s)
        For i = 0 To 3

            ' Test if counter used
            If (CounterList(i).Checked = True) Then

                ' Disable the syncho latch
                RetValue = MSXE170x.MFIncCounterDisableAndReleaseLatchRegister(i, 1, 0, syserno)

                If (RetValue <> 0) Then

                    MessageBox.Show("MFIncCounterDisableAndReleaseLatchRegister Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            End If
        Next i

        ' Button initialisation
        B_CounterInitialisation.Enabled = False
        B_CounterReleaseInitialisation.Enabled = True
        B_ClearCounter.Enabled = True
        B_WriteCounter.Enabled = True
        B_StartCounterAcquisition.Enabled = True
        B_StopCounterAcquisition.Enabled = False
        GB_CounterConfig.Enabled = False
        GB_Acquisition.Enabled = True
    End Sub

    Private Sub ClientThreadFct()
        Dim SocketData(Client.SingleFramesSize) As Byte
        Dim StreamCounter As Integer = 0
        Dim Offset As Integer = 0
        Dim Counter As Integer = 0
        Dim AcquisitionCounter As ULong = 0
        Dim sOutString As String

        While (True)
            SocketData = Client.ReadData()

            If (Not IsNothing(SocketData)) Then
                sOutString = ""
                Offset = 0

                For StreamCounter = 0 To (Client.NbrOfFrames - 1)

                    For Counter = 0 To (Counters - 1)
                        Offset = (StreamCounter + (Client.NbrOfFrames * Counter)) * 5 * 4
                        ' 
                        sOutString = sOutString + "Acquisition counter: " + AcquisitionCounter.ToString()

                        ' Get the time stamp
                        sOutString = sOutString + " / Time stamp: " + ConvertFromTime_T(SocketData, Offset)
                        Offset = Offset + 8

                        ' Get the counter nbr
                        sOutString = sOutString + " / counter: " + BitConverter.ToUInt32(SocketData, Offset).ToString()
                        Offset = Offset + 4

                        ' Get the source
                        sOutString = sOutString + " / source: " + BitConverter.ToUInt32(SocketData, Offset).ToString()
                        Offset = Offset + 4

                        ' Get the counter value
                        sOutString = sOutString + " / value: " + BitConverter.ToUInt32(SocketData, Offset).ToString() + Environment.NewLine

                        AcquisitionCounter = AcquisitionCounter + 1
                    Next Counter
                Next StreamCounter

                DisplayText = DisplayText + sOutString
            Else
                Exit While
            End If
        End While
    End Sub

    Private Sub DisplayTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DisplayTimer.Tick
        TB_Values.Text = DisplayText
    End Sub
End Class
